/*
 * uart.h
 *
 * Created: 15.08.2013 15:25:55
 *  Author: 29ObrubovVU
 */ 


#ifndef UART_H_
#define UART_H_

//UART functions
void USART_Init()
{
	/* Set baud rate */
	UBRR0L = F_CPU / (19200 * 16L) - 1;
	UCSR0B = ( 1<<TXEN0 );//Разрешаем передачу данных
}


static void uartPutc(char c)
{
	while(!(UCSR0A & (1 << UDRE0)));    /* wait for data register empty */
	UDR0 = c;
}

static uchar hexAscii(uchar h)
{
	h &= 0xf;
	if(h >= 10)
	h += 'a' - (uchar)10 - '0';
	h += '0';
	return h;
}

static void printHex(uchar c)
{
	uartPutc(hexAscii(c >> 4));
	uartPutc(hexAscii(c));
}

//Функция отправки сообщения
void msgout (uchar *data,uchar len, uchar hex, uchar eoln)
{

	while(len--){
		if (hex) {
			printHex(*data++);
			uartPutc(' ');
		}
		else
		{
			uartPutc(*data++);
		}
	}
	if (eoln) {
		uartPutc('\r');
		uartPutc('\n');
	}
}
//Функция отправки сообщения
void msgoute (uchar *data,uchar len, uchar hex, uchar eoln)
{
	if(*(data + 3) != 0) {
		printHex(*(data + 3));
		if(*(data + 4) != 0) {
			uartPutc(' ');
			printHex(*(data + 4));
			if(*(data + 5) != 0) {
				uartPutc(' ');
				printHex(*(data + 5));
			}
		}
	}
	if (eoln) {
		uartPutc('\r');
		uartPutc('\n');
	}
}
// END UART funtions


#endif /* UART_H_ */